function giveConsentGC(detail) {

	if (detail !== null && typeof detail.gc_consent_universal_analytics !== 'undefined') {
		CheckConsentGoogle(detail, 'universal_analytics');
	}
	if (detail !== null && typeof detail.gc_consent_google_tagmanager !== 'undefined') {
		CheckConsentGoogle(detail, 'google_tagmanager');
	}
	if (detail !== null && typeof detail.gc_consent_optimize !== 'undefined') {
		CheckConsentGoogle(detail, 'optimize');
	}

	if (detail !== null && typeof detail.gc_analytics !== 'undefined') {
		if (typeof gtag !== 'undefined') {
			if (detail.gc_analytics === true) {
				gtag('consent', 'update', {
				  //ad_storage: 'denied',
				  analytics_storage: 'granted',
				  functionality_storage: 'granted',
				  personalization_storage: 'granted'
				});
				console.log('Consent für Analytics (gtag) gewährt');
			} else {
				gtag('consent', 'update', {
				  //ad_storage: 'denied',
				  analytics_storage: 'denied',
				  functionality_storage: 'denied',
				  personalization_storage: 'denied'
				});
				console.log('Consent für Analytics (gtag) entzogen');
			}
		}
	}
	if (detail !== null && typeof detail.gc_adwords !== 'undefined') {
		if (typeof gtag !== 'undefined') {
			if (detail.gc_adwords === true) {
				gtag('consent', 'update', {
				  //ad_storage: 'denied',
				  ad_storage: 'granted',
				  functionality_storage: 'granted',
				  personalization_storage: 'granted'
				});
				gtag('set', 'ads_data_redaction', false);
				console.log('Consent für Adwords gewährt');
			} else {
				gtag('consent', 'update', {
				  //ad_storage: 'denied',
				  ad_storage: 'denied',
				  functionality_storage: 'denied',
				  personalization_storage: 'denied'
				});
				gtag('set', 'ads_data_redaction', true);
				console.log('Consent für Adwords entzogen');

			}
		}
	}
}



function CheckConsentGoogle(detail, service, dependencies = '') {
	if (eval('detail.gc_consent_' + service) === true) {
		if (dependencies == '') {
			$('head script[data-gc-cmp-id="' + service  + '"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						GoogleConsentAddScript(service, index, f, document.head, detail);
					}, 200, this);
				}
			});
			$('body script[data-gc-cmp-id="' + service  + '"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						GoogleConsentAddScript(service, index, f, document.body, detail);
					}, 200, this);
				}
			});
			console.log('Consent für ' + service  + ' gewährt');
		} else {
			$('head script[data-gc-cmp-id="' + service  + '"][data-dep-id="' + dependencies  + '"]').each(function (index) {
				setTimeout (function(f){
					GoogleConsentAddScript(service, index, f, document.head, detail);
				}, 200, this);
			});
			$('body script[data-gc-cmp-id="' + service  + '"][data-dep-id="' + dependencies  + '"]').each(function (index) {
				setTimeout (function(f){
					GoogleConsentAddScript(service, index, f, document.body, detail);
				}, 200, this);
			});
			console.log('Consent für ' + service  +  ' (dep ' + dependencies + ') gewährt');
		}
	} else {
		console.log('Consent für ' + service  + ' entzogen');
	}
}

function GoogleConsentAddScript(service, index, element, parent, detail) {
	var script = document.createElement("script");
	script.setAttribute("type", "text/javascript");
	script.async = true;
	script.defer = true;
	if (typeof $(element).attr('src') !== "undefined") {
		script.setAttribute("src", $(element).attr('src'));
	//	if (typeof $(element).attr('data-onload') !== "undefined") {
		//		//script.addEventListener('load', $(element).attr('data-onload'));
	//		script.onload = eval('window.onload = function() {' + $(element).attr('data-onload') + '};');
	//		console.log('loaded');
	//	}
	}
	//console.log($(element).text());
	//script.innerText =  $(element).text();
	setInnerHTML(script, $(element).text());
	script.setAttribute("data-gc-cmp-set-id", service);
	script.setAttribute("data-gc-consent-given", "true");
	if (element.hasAttribute('data-dependencies')) {
		script.addEventListener("load", function(event) {
			console.log(service + ': dependencies on src');
			CheckConsentGoogle(detail, service, element.getAttribute('data-dependencies'));
		});
		if (!script.hasAttribute('src')) {
			console.log(service + ': dependencies without src');
			CheckConsentGoogle(detail, service, element.getAttribute('data-dependencies'));
		}
	}
	element.parentNode.replaceChild(script, element);
}



var setInnerHTML = function(elm, html) {
  elm.innerHTML = html;
  Array.from(elm.querySelectorAll("script")).forEach( oldScript => {
    const newScript = document.createElement("script");
    Array.from(oldScript.attributes)
      .forEach( attr => newScript.setAttribute(attr.name, attr.value) );
    newScript.appendChild(document.createTextNode(oldScript.innerHTML));
    oldScript.parentNode.replaceChild(newScript, oldScript);
  });
}